package com.lj360.memberdata;

import com.alibaba.fastjson.JSONObject;
import com.fasterxml.jackson.databind.ObjectMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.core.AuthenticationException;
import org.springframework.security.web.authentication.SimpleUrlAuthenticationFailureHandler;
import org.springframework.stereotype.Component;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;

@Component("ssbAuthenctiationFailureHandler")
public class SsbAuthenctiationFailureHandler extends SimpleUrlAuthenticationFailureHandler {

    @Autowired
    private ObjectMapper objectMapper;


    /* (non-Javadoc)
     * @see org.springframework.security.web.authentication.AuthenticationFailureHandler#onAuthenticationFailure(javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse, org.springframework.security.core.AuthenticationException)
     */
    @Override
    public void onAuthenticationFailure(HttpServletRequest request, HttpServletResponse response,
                                        AuthenticationException exception) throws IOException, ServletException {

        System.out.println("----------login faiule-------");
//        super.onAuthenticationFailure(request, response, exception);

//        request.setCharacterEncoding("UTF-8");
//        response.setCharacterEncoding("UTF-8");
        response.setContentType("text/html;charset=utf-8");

        JSONObject postData = new JSONObject();
        JSONObject user = new JSONObject();
        postData.put("success", true);
        postData.put("msg","登陆错误，请检查用户名密码");
        user.put("id", "");
        user.put("username",request.getParameter("username"));
        user.put("password",request.getParameter("password"));
        postData.put("user",user);

        response.getWriter().write(objectMapper.writeValueAsString(postData));
    }
}
