package com.lj360.memberdata.service;

import com.alibaba.fastjson.JSONObject;
import com.lj360.memberdata.repository.AccountRepository;
import com.lj360.memberdata.domain.Account;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.core.authority.AuthorityUtils;
import org.springframework.security.core.userdetails.User;
import org.springframework.security.core.userdetails.UserDetails;
import org.springframework.security.core.userdetails.UserDetailsService;
import org.springframework.security.core.userdetails.UsernameNotFoundException;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.client.RestTemplate;

import java.util.List;

@Component("userDetailsService")
public class CustomizeUserDetailsService
            implements UserDetailsService {

    //    @Autowired
//    private UserRepository userRepository;
    private Logger logger = LoggerFactory.getLogger(getClass());

    @Autowired
    private RestTemplate restTemplate;

    @Autowired
    private AccountRepository accountRepo;

    @Override
    @Transactional
    public UserDetails loadUserByUsername(String username) throws UsernameNotFoundException {
        String lowerUsername = username.toLowerCase();
        logger.info("用户的用户名: {}", lowerUsername);

        List<Object[]> accounts = accountRepo.getByUserName(username);

        Account account = new Account();
        if(accounts!=null && accounts.size()>0) {
            account.setAccountName((String) accounts.get(0)[1]);
            account.setAccountPassWord((String) accounts.get(0)[2]);
        }
        System.out.println("account=>" + account.getAccountName());


        // 封装用户信息，并返回。参数分别是：用户名，密码，用户权限
//        User user = new User(username, "123456",
//                AuthorityUtils.commaSeparatedStringToAuthorityList(username+""));
        User user = new User(username, account.getAccountPassWord(),
                AuthorityUtils.commaSeparatedStringToAuthorityList(username+""));
        return user;
    }
}